package org.jnetpcap.examples;  

import java.io.*;
import java.util.Scanner;
import java.nio.ByteBuffer;  
import java.util.ArrayList;  
import java.util.Arrays;  
import java.util.List;  
  
import org.jnetpcap.Pcap;  
import org.jnetpcap.PcapIf;  
  
public class LLCSend {  
  public static void main(String[] args) throws IOException {  
    List<PcapIf> alldevs = new ArrayList<PcapIf>(); // Tutte le intefacce da rilevare  
    StringBuilder errbuf = new StringBuilder();     // eventuali messaggi di errore  
    int j,r;
    byte[] pkt = new byte[100];  

    r = Pcap.findAllDevs(alldevs, errbuf);  
    if (r == Pcap.NOT_OK || alldevs.isEmpty()) {  
      System.err.printf("Impossibile leggere la lista delle interfacce: %s", errbuf.toString());  
      return;  
    }
    
	for (j = 0; j < alldevs.size(); j++) 
	{
		PcapIf device = alldevs.get(j);
		System.out.printf("\nNIC %d: %s\nNome: %s\n",j+1, device.getDescription(), device.getName());
	}

    Scanner in = new Scanner(System.in);
    System.out.printf("\nScegliere una interfaccia: ");
    j = in.nextInt() - 1; 
    
    PcapIf device = alldevs.get(j);   
    int snaplen = 65536; 	          // dimensione del pacchetto da catturare (non serve)  
    int flags = Pcap.DEFAULT_PROMISC; // impostazione del modo promniscuo  
    int timeout = 1000;               // timeout di lettura (non serve)
    // apertura dell'interfaccia di rete
    Pcap pcap = Pcap.openLive(device.getName(), snaplen, flags, timeout, errbuf);   

    
    // Indirizzo MAC destinazione
    pkt[0] = 0x01; pkt[1] = 0x01; pkt[2] = 0x01; pkt[3] = 0x01; pkt[4] = 0x01; pkt[5] = 0x01;
    // Indirizzo MAC mittente
    pkt[6] = 0x02; pkt[7] = 0x02; pkt[8] = 0x02; pkt[9] = 0x02; pkt[10] = 0x02; pkt[11] = 0x02;

  	// pacchetto da 100 byte, praticamente casuale...
  	for(int i=12; i<100; i++)
  	{
  		pkt[i]= (byte)i;
  	}    

  	ByteBuffer b = ByteBuffer.wrap(pkt);
    // Spedizione del pacchetto sull'interfaccia specificata
    if (pcap.sendPacket(b) != Pcap.OK) {  
      System.err.println(pcap.getErr());  
    }  
  
    pcap.close();  
    return;
  }  
}  